<?php

namespace App\Wrangler\Components;

use Illuminate\Http\Request;
use Medialight\Textstem\Models\WranglerPage;
use Medialight\Textstem\Wrangler\ActiveComponent;

/**
 * Class Sample
 *
 * A short summary of what this component does.
 *
 * @extends ActiveComponent
 */
class Table extends ActiveComponent
{
    public static string $description = 'Render a table from a list of rows.';
    public static string $version = '1.0.0';

    public $config;

    public array $editSetup = [
        [
            'name' => 'template',
            'controltype' => 'select-template',
            'value' => 'default',
        ],
        [
            'name' => 'title',
            'controltype' => 'text',
            'value' => '',
            'label' => 'Title',
        ],
        [
            'name' => 'table',
            'controltype' => 'table',
            'columnCount' => 3,
            'value' => '',
            'label' => 'Rows',
        ],
        [
            'name' => 'showHeadings',
            'controltype' => 'select',
            'options' => ['none', 'first row', 'first column'],
            'value' => 'none',
            'label' => 'Show first row as headings',
        ],
    ];

    public function render(Request $request, WranglerPage $wranglerPage)
    {
        $view = $this->getView();
        $data = $this->data();
        // add any extra stuff the view needs to $data
        return view($view, $data)->render();
    }

    public function preview()
    {
        $view = $this->getPreview();
        $data = $this->data();
        return view($view, $data)->render();
    }
}
